#ifndef CAMERA_H
#define CAMERA_H

#include "cpgl.h"

typedef struct {
    GLfloat     m[16]; // gl matrix style... column, row order to orient
    GLfloat     pos[3];
} Camera;

// -- camera manipulation
// -- absolute manipulations
void position_camera        (float  x, float  y, float  z);

void orient_camera          (float  p, float  y, float  r);
void orient_camera          (float* mat4_basis);

void get_camera_position    (float* x, float* y, float* z);
void get_camera_orientation (float* mat4_basis);

// -- relative manipulations
void turn_camera            (float  p, float  y, float  r); // in radians
void translate_camera       (float  x, float  y, float  z);

void apply_camera_matrix();
void unapply_camera_matrix();

#endif

