uniform sampler2D nmap;
uniform sampler2D cmap;
uniform float     scale;
uniform float     bias;
uniform int       DoLighting;
uniform int       apply_parallax;
varying vec3      evec;
varying vec3      lvec;
varying vec3      hvec;
 
void main()
{
    vec4  lcolor;
    float specular;
    float height  = texture2D(nmap, gl_TexCoord[0].st).a;

    // scale is .04 and bias is -.02 (s = .04), (b = s * -.5)
    vec2  newtc;
    if( apply_parallax == 1 )
        newtc = gl_TexCoord[0].st + ((height * scale - bias) * (-evec.xy));
    else
        newtc = gl_TexCoord[0].st;

    vec4  ntex    = texture2D(nmap, newtc);
    vec3  ndelta  = normalize( (ntex.rgb - .5) * 2.0);
    float diffuse = max(0.0, dot(ndelta,normalize(lvec)));
    specular = clamp(dot(reflect(-evec,ndelta), lvec), 0.0, 1.0);
    specular = pow( specular, gl_FrontMaterial.shininess);

    vec4  difclr  = gl_LightSource[0].diffuse * gl_FrontMaterial.diffuse
                    * diffuse;
    vec4  ambclr  = gl_LightSource[0].ambient * gl_FrontMaterial.ambient;
    vec4  spcclr  = gl_LightSource[0].specular * gl_FrontMaterial.specular 
                    * specular;

    lcolor   = texture2D(cmap, newtc);
    lcolor.a = 1.0;
    lcolor = lcolor * ambclr + (lcolor * difclr + spcclr);

    gl_FragColor = lcolor; 
}

