varying   vec3   evec;
varying   vec3   lvec;
varying   vec4   projCoord;
varying   float  ecz;
varying   vec3   opos;

attribute vec3   Tangent;
uniform   int    DoLighting;

void main()
{
    gl_TexCoord[0] = gl_MultiTexCoord0;
   
    opos = gl_Vertex.xyz;
    
    vec3 normal   = normalize(gl_NormalMatrix * gl_Normal);
    vec3 tangent  = normalize(gl_NormalMatrix * Tangent); 
    vec3 binormal = cross(normal, tangent);
    vec3 ev = normalize(vec3( gl_ModelViewMatrix * gl_Vertex));
    ecz = ev.z;
    vec3 lv = normalize(gl_LightSource[0].position.xyz);
    lvec = vec3( dot(lv, tangent), dot(lv, binormal), dot(lv, normal));
    lvec = normalize(lvec);
    ev   = -ev;
    evec = vec3( dot(ev,tangent), dot(ev,binormal), dot(ev,normal));
    evec = normalize(evec);
    gl_Position    = ftransform();
}
