varying   vec4 projcoord;
attribute vec3 Tangent;
varying   vec3 evec;
varying   vec3 pos;
varying   vec4 ltspace;
varying   vec4 etspace;
varying   vec4 viewCoord;

uniform   sampler2D NormalMapTex;

void main()
{
    // assume normal is +y
    // tangent is +x
    // binormal is +z
    gl_TexCoord[0] = gl_MultiTexCoord0;
    evec        = normalize( vec3(gl_ModelViewMatrix * gl_Vertex) );
    
    vec3 tangent = vec3( 1.0, 0.0, 0.0 );
    vec3 binorm  = vec3( 0.0, 0.0, 1.0 );
    vec3 normal  = vec3( 0.0, 1.0, 0.0 );

    vec3 temp;
    temp = normalize( gl_LightSource[0].position.xyz);
    ltspace = vec4( 
        dot(temp, tangent), 
        dot(temp,binorm), 
        dot(temp,normal),
        1.0);


    temp = -evec;
    etspace =  vec4( 
        dot(temp,tangent), 
        dot(temp,binorm), 
        dot(temp,normal),
        1.0);; 
    
    viewCoord = gl_ModelViewProjectionMatrix * gl_Vertex;
    gl_Position = viewCoord;
}
