attribute vec3 Tangent; // tangent vector for this vertex


varying vec3 light;
varying vec3 view;

void main()
{
    mat3 T;

    vec3 eye = vec3(gl_ModelViewMatrix * gl_Vertex);
    vec3 tmp = gl_LightSource[0].position.xyz - eye;

    // Compute the orthonormalizes tangent space basis.

    T[0] = normalize(gl_NormalMatrix * Tangent);
    T[2] = normalize(gl_NormalMatrix * gl_Normal);
    T[1] = normalize(cross(T[2], T[0]));

    // Transform the light and view vectors into tangent space.

    light = tmp * T;
    view  = eye * T;

    gl_TexCoord[0] = gl_MultiTexCoord0;
    gl_Position = ftransform();
}

