uniform vec2      Src;
uniform float     Amp;
uniform float     Time;
uniform float     StartTime;
uniform float     Frequency;
uniform float     Speed;
uniform sampler2D PrevItr;

varying vec2      pos;

// Offset of zero plane by .5
// Hieght_i = Amp * sin( dot( Dir.xy, Pos.xy ) * Frequency + (t - t0) * Speed)
// Hieght   = Sum( Hieght_i, 1, n ) + .5

void main()
{
    // normalized direction
    vec2 Dir = pos - Src;
    // sum of hieghts up til now
    float height = texture2D( PrevItr, gl_TexCoord[0].st ).a;
    height +=
        Amp * sin( -length(Dir) * Frequency + (Time * Speed));
    gl_FragColor = vec4( .0, .0, .0, height );
}

